#!/bin/bash -x

# Copyright (c) 2024 Maxwell G <maxwell@gtmx.me>
# SPDX-License-Identifier: GPL-2.0-or-later

set -euo pipefail

PYTHON="${PYTHON:-python3}"
find_package_maintainers="https://pagure.io/fedora-misc-package-utilities/raw/master/f/find-package-maintainers"

# Download find-package-maintainers script
curl -o tools/find-package-maintainers "${find_package_maintainers}"

if [ -z "${frozen-}" ]; then
    # Generate base data
    xargs -d'\n' "${PYTHON}" tools/go_leaves.py \
        all \
        --no-error-for-invalid-ignores -I < <(ls opt-out/)

else
    # Manually clean leaves data
    while read -r package; do
        sed -i "/${package}/d" leaves
    done < <(ls opt-out/)

    # Refresh binaries but leave outliers and leaves data untouched
    tools/go_leaves.py \
        binaries -o binaries \
        --no-error-for-invalid-ignores -I < <(ls opt-out/)
fi


# Generate by-maintainer data
for type in "all_packages" "binaries" "leaves" "outliers"; do
    "${PYTHON}" tools/find-package-maintainers \
        <"${type}" >"${type}-by-maintainer"
done

# Create a separate list of orphaned outliers
#
# Disable pipefail. It's okay for the file to be empty.
( set +o pipefail; grep ' orphan$' outliers-by-maintainer | cut -f1 -d' ' >outliers-orphan)

# Create a list of binaries that depend on orphaned libraries
# Depends on files generated by previous steps.
"${PYTHON}" tools/orphan_affected.py |& tee binaries-orphan_affected
